// Name and Surname
// Grade 12
// Information Technology
// Paper 1
// August 2024

unit Question3_U;

interface
uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Spin, ExtCtrls, Crypto_U, Buttons, ComCtrls;
type
  TfrmQuestion3 = class(TForm)
    pnlHeading: TPanel;
    btnLive: TButton;
    grpQ3_2_1: TGroupBox;
    bmpClose: TBitBtn;
    grpQ3_2_3: TGroupBox;
    pnlLive: TPanel;
    bmpReset: TBitBtn;
    pnlBtns: TPanel;
    grpQ3_2_2: TGroupBox;
    pnlMain: TPanel;
    pnlLeft: TPanel;
    pnlRight: TPanel;
    redOutput: TRichEdit;
    btnStop: TButton;
    tmrLive: TTimer;
    btn3_2_2: TButton;
    rgpCrypto: TRadioGroup;
    pnl3_2_1Left: TPanel;
    btn3_2_1: TButton;
    lblName: TLabel;
    lblSurname: TLabel;
    edtName: TEdit;
    edtSurname: TEdit;
    lblMoney: TLabel;
    edtMoney: TEdit;
    pnlOutput: TPanel;
    procedure btnLiveClick(Sender: TObject);
    procedure bmpResetClick(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure btn3_2_2Click(Sender: TObject);
    procedure btnStopClick(Sender: TObject);
    procedure btn3_2_1Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tmrLiveTimer(Sender: TObject);
  private
  public
  end;
var
  frmQuestion3: TfrmQuestion3;
  // Provided code - DO NOT DELETE OR ALTER //
  objCrypto : TCrypto;

implementation

{$R *.dfm}

// ===========================================================
// Question 3.2.1 - 6 Marks
// ===========================================================
procedure TfrmQuestion3.btn3_2_1Click(Sender: TObject);
begin
  /// Enter your code below ///


  // Provided code - DO NOT DELETE OR ALTER //
  btn3_2_2.Enabled := True;
end;

// ===========================================================
// Question 3.2.2 - 2 Marks
// ===========================================================
procedure TfrmQuestion3.btn3_2_2Click(Sender: TObject);
begin
  /// Enter your code below ///


  // Provided code - DO NOT DELETE OR ALTER //
  btnLive.Enabled := True;
end;

// ===========================================================
// Question 3.2.3 - 5 Marks
// ===========================================================
procedure TfrmQuestion3.tmrLiveTimer(Sender: TObject);
begin
  /// Enter your code below ///
  
end;

//////////////////////////////////////////////////////////////
/////    Provided Code - DO NOT DELETE OR ALTER     //////////
//////////////////////////////////////////////////////////////
{$REGION 'Setup Code'}

  procedure TfrmQuestion3.FormActivate(Sender: TObject);
  begin
    frmQuestion3.Constraints.MinWidth  := 650;
    frmQuestion3.Constraints.MinHeight := 500;

    btnLive.Enabled   := False;
    btnStop.Enabled   := False;
    tmrLive.Enabled   := False;
    btn3_2_2.Enabled := False;
    edtName.Text    := 'Joe';
    edtSurname.Text := 'Soap';
    edtMoney.Text   := '50000';
    rgpCrypto.ItemIndex := 1;
    with redOutput do
      begin
        Clear;
        ScrollBars := ssBoth;
        Paragraph.TabCount := 3;
        Paragraph.Tab[0] := 30;
        Paragraph.Tab[1] := 100;
        Paragraph.Tab[2] := 150;
      end;
  end;

  procedure TfrmQuestion3.FormClose(Sender: TObject; var Action: TCloseAction);
  begin
    objCrypto.Free;
  end;

  procedure TfrmQuestion3.FormResize(Sender: TObject);
  begin
    pnlHeading.Height  := round(frmQuestion3.Height * 0.08);
    pnlMain.Height     := round(frmQuestion3.Height * 0.74);
    pnlLeft.Width      := round(pnlMain.Width * 0.5);
    grpQ3_2_1.Height   := round(pnlMain.Height * 0.55);
    pnl3_2_1Left.Width := round(grpQ3_2_1.Width * 0.55);
    btnLive.Width      := round(grpQ3_2_3.Width * 0.45);
  end;

  procedure TfrmQuestion3.bmpResetClick(Sender: TObject);
  begin
    redOutput.Clear;
    btnLive.Enabled := False;
    btnStop.Enabled := False;
    tmrLive.Enabled := False;
    btn3_2_2.Enabled := False;
    edtName.Clear;
    edtSurname.Clear;
    edtMoney.Clear;
    rgpCrypto.ItemIndex := 0;
    edtName.SetFocus;
  end;

  procedure TfrmQuestion3.btnLiveClick(Sender: TObject);
  begin
    btnLive.Enabled := False;
    btnStop.Enabled := True;
    tmrLive.Enabled := True;
  end;

  procedure TfrmQuestion3.btnStopClick(Sender: TObject);
  begin
    btnLive.Enabled := True;
    btnStop.Enabled := False;
    tmrLive.Enabled := False;
  end;

{$ENDREGION}
end.
